## rtslib 2.2

=== Makefile ===
# This file is part of RTSLib.
# Copyright (c) 2011-2013 by Datera, Inc
#
# Licensed under the Apache License, Version 2.0 (the "License"); you may
# not use this file except in compliance with the License. You may obtain
# a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
#     Unless required by applicable law or agreed to in writing, software
#     distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
#     WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
#     License for the specific language governing permissions and limitations
#     under the License.
#

NAME = rtslib
GIT_BRANCH = $$(git branch | grep \* | tr -d \*)
VERSION = $$(basename $$(git describe --tags | tr - .))

all:
	@echo "Usage:"
	@echo
	@echo "  make deb         - Builds debian packages."
	@echo "  make rpm         - Builds rpm packages."
	@echo "  make release     - Generates the release tarball."
	@echo
	@echo "  make clean       - Cleanup the local repository build files."
	@echo "  make cleanall    - Also remove dist/*"

clean:
	@rm -fv ${NAME}/*.pyc ${NAME}/*.html
	@rm -frv doc
	@rm -frv ${NAME}.egg-info MANIFEST build
	@rm -frv debian/tmp
	@rm -fv build-stamp
	@rm -fv dpkg-buildpackage.log dpkg-buildpackage.version
	@rm -frv *.rpm
	@rm -fv debian/files debian/*.log debian/*.substvars
	@rm -frv debian/${NAME}-doc/ debian/python2.5-${NAME}/
	@rm -frv debian/python2.6-${NAME}/ debian/python-${NAME}/
	@rm -frv results
	@rm -fv rpm/*.spec *.spec rpm/sed* sed*
	@rm -frv ${NAME}-*
	@echo "Finished cleanup."

cleanall: clean
	@rm -frv dist

release: build/release-stamp
build/release-stamp:
	@mkdir -p build
	@echo "Exporting the repository files..."
	@git archive ${GIT_BRANCH} --prefix ${NAME}-${VERSION}/ \
		| (cd build; tar xfp -)
	@echo "Cleaning up the target tree..."
	@rm -f build/${NAME}-${VERSION}/Makefile
	@rm -f build/${NAME}-${VERSION}/.gitignore
	@echo "Fixing version string..."
	@sed -i "s/__version__ = .*/__version__ = '${VERSION}'/g" \
		build/${NAME}-${VERSION}/${NAME}/__init__.py
	@echo "Generating rpm specfile from template..."
	@cd build/${NAME}-${VERSION}; \
		for spectmpl in rpm/*.spec.tmpl; do \
			sed -i "s/Version:\( *\).*/Version:\1${VERSION}/g" $${spectmpl}; \
			mv $${spectmpl} $$(basename $${spectmpl} .tmpl); \
		done; \
		rm -r rpm
	@echo "Generating rpm changelog..."
	@( \
		version=$$(basename $$(git describe HEAD --tags | tr - .)); \
		author=$$(git show HEAD --format="format:%an <%ae>" -s); \
		date=$$(git show HEAD --format="format:%ad" -s \
			| awk '{print $$1,$$2,$$3,$$5}'); \
		hash=$$(git show HEAD --format="format:%H" -s); \
	   	echo '* '"$${date} $${author} $${version}-1"; \
		echo "  - Generated from git commit $${hash}."; \
	) >> $$(ls build/${NAME}-${VERSION}/*.spec)
	@echo "Generating debian changelog..."
	@( \
		version=$$(basename $$(git describe HEAD --tags | tr - .)); \
		author=$$(git show HEAD --format="format:%an <%ae>" -s); \
		date=$$(git show HEAD --format="format:%aD" -s); \
		day=$$(git show HEAD --format='format:%ai' -s \
			| awk '{print $$1}' \
			| awk -F '-' '{print $$3}' | sed 's/^0/ /g'); \
		date=$$(echo $${date} \
			| awk '{print $$1, "'"$${day}"'", $$3, $$4, $$5, $$6}'); \
		hash=$$(git show HEAD --format="format:%H" -s); \
	   	echo "${NAME} ($${version}) unstable; urgency=low"; \
		echo; \
		echo "  * Generated from git commit $${hash}."; \
		echo; \
		echo " -- $${author}  $${date}"; \
		echo; \
	) > build/${NAME}-${VERSION}/debian/changelog
	@find build/${NAME}-${VERSION}/ -exec \
		touch -t $$(date -d @$$(git show -s --format="format:%at") \
			+"%Y%m%d%H%M.%S") {} \;
	@mkdir -p dist
	@cd build; tar -c --owner=0 --group=0 --numeric-owner \
		--format=gnu -b20 --quoting-style=escape \
		-f ../dist/${NAME}-${VERSION}.tar \
		$$(find ${NAME}-${VERSION} -type f | sort)
	@gzip -6 -n dist/${NAME}-${VERSION}.tar
	@echo "Generated release tarball:"
	@echo "    $$(ls dist/${NAME}-${VERSION}.tar.gz)"
	@touch build/release-stamp

deb: release build/deb-stamp
build/deb-stamp:
	@echo "Building debian packages..."
	@cd build/${NAME}-${VERSION}; \
		dpkg-buildpackage -rfakeroot -us -uc
	@mv build/*_${VERSION}_*.deb dist/
	@echo "Generated debian packages:"
	@for pkg in $$(ls dist/*_${VERSION}_*.deb); do echo "  $${pkg}"; done
	@touch build/deb-stamp

rpm: release build/rpm-stamp
build/rpm-stamp:
	@echo "Building rpm packages..."
	@mkdir -p build/rpm
	@build=$$(pwd)/build/rpm; dist=$$(pwd)/dist/; rpmbuild \
		--define "_topdir $${build}" --define "_sourcedir $${dist}" \
		--define "_rpmdir $${build}" --define "_buildir $${build}" \
		--define "_srcrpmdir $${build}" -ba build/${NAME}-${VERSION}/*.spec
	@mv build/rpm/*-${VERSION}*.src.rpm dist/
	@mv build/rpm/*/*-${VERSION}*.rpm dist/
	@echo "Generated rpm packages:"
	@for pkg in $$(ls dist/*-${VERSION}*.rpm); do echo "  $${pkg}"; done
	@touch build/rpm-stamp

## rtslib 2.1

=== debian/changelog ===
rtslib (2.1-2) unstable; urgency=low

  * Upload to unstable 

 -- Ritesh Raj Sarraf <rrs@debian.org>  Mon, 12 Dec 2011 16:53:44 +0530

rtslib (2.1-1) experimental; urgency=low

  * Initial release. (Closes: #627104)

 -- Ritesh Raj Sarraf <rrs@debian.org>  Fri, 02 Dec 2011 01:01:14 +0530

=== debian/control ===
Source: rtslib
Section: python
Priority: optional
Maintainer: Ritesh Raj Sarraf <rrs@debian.org>
Build-Depends: debhelper(>= 7.0.50~), python(>= 2.6.6-3~), python-ipaddr, python-netifaces, python-configobj, python-epydoc, python-simpleparse, texlive-latex-base, texlive-latex-extra, texlive-latex-recommended, lmodern, ghostscript
Standards-Version: 3.9.2
Homepage: http://www.risingtidesystems.com/git/?p=rtslib.git;a=summary
Vcs-Git: git://git.debian.org/git/linux-target/rtslib.git
Vcs-Browser: http://git.debian.org/?p=linux-target/rtslib.git

Package: python-rtslib
Architecture: all
Depends: ${python:Depends}, ${misc:Depends}, python-ipaddr, python-netifaces, python-configobj
Provides: ${python:Provides}
Description: LIO core target management framework - python libs
 This package contains the LIO rtslib library that provides an object API
 to the LIO SCSI Target as well as third-party target fabric modules
 .
 It is part of the Linux Kernel SCSI Target's userspace management library

## rtslib 2.1.fb27

=== debian/changelog ===
rtslib (2.1.fb27-0ubuntu1) raring; urgency=low

  * New upstream release. 

 -- Chuck Short <zulcss@ubuntu.com>  Mon, 18 Feb 2013 08:41:27 -0600

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,11 @@
 Source: rtslib
 Section: python
 Priority: optional
-Maintainer: Ritesh Raj Sarraf <rrs@debian.org>
-Build-Depends: debhelper(>= 7.0.50~), python(>= 2.6.6-3~), python-ipaddr, python-netifaces, python-configobj, python-epydoc, python-simpleparse, texlive-latex-base, texlive-latex-extra, texlive-latex-recommended, lmodern, ghostscript
-Standards-Version: 3.9.2
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Ritesh Raj Sarraf <rrs@debian.org>
+Build-Depends: debhelper(>= 7.0.50~), python(>= 2.6.6-3~), python-ipaddr, python-netifaces, python-configobj, 
+ python-epydoc, python-simpleparse, texlive-latex-base, texlive-latex-extra, texlive-latex-recommended, lmodern, ghostscript
+Standards-Version: 3.9.4
 Homepage: http://www.risingtidesystems.com/git/?p=rtslib.git;a=summary
 Vcs-Git: git://git.debian.org/git/linux-target/rtslib.git
 Vcs-Browser: http://git.debian.org/?p=linux-target/rtslib.git

## rtslib 2.1.fb27.isreally.2.1

=== debian/changelog ===
rtslib (2.1.fb27.isreally.2.1-0ubuntu2) raring; urgency=low

  * d/python-rtslib.install: Install missing spec files into
    /var/target/fabric.

 -- James Page <james.page@ubuntu.com>  Tue, 09 Apr 2013 22:13:40 +0100

rtslib (2.1.fb27.isreally.2.1-0ubuntu1) raring; urgency=low

  * Revert to original upstream source as the fork is not object
    compatible and breaks targetcli (LP: #1166042):
    - d/watch: Revert changes from 2.1.fb27-0ubuntu2.
    - d/control,copyright: Revert changes from 2.1.fb27-0ubuntu2.
    - d/python-rtslib.dirs: Revert changes from 2.1.fb27-0ubuntu2.

 -- James Page <james.page@ubuntu.com>  Mon, 08 Apr 2013 12:55:56 +0100

rtslib (2.1.fb27-0ubuntu2) raring; urgency=low

  * Fix package build so that it ships egginfo (LP: #1126378):
    - d/rules: Use more of dh_python2 automagic.
    - d/python-rtslib.dirs: Don't create pyshared dir.
     -d/python-rtslib.install: Dropped - handled by dh_python2.
  * d/control: Dropped python-netaddr, python-ipaddr, python-configobj
    and python-simpleparse as no longer needed.
  * d/watch: Added watch on pypi.python.org for release tarballs.
  * d/python-rtslib.dirs: Create /var/lib/target/fabric not
    /var/target/fabric inline with code.
  * d/control,copyright: Updated to point to free-branch upstream.

 -- James Page <james.page@ubuntu.com>  Wed, 27 Feb 2013 09:50:43 +0000

=== debian/control ===
--- 
+++ 
@@ -3,9 +3,8 @@
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Ritesh Raj Sarraf <rrs@debian.org>
-Build-Depends: debhelper(>= 7.0.50~), python(>= 2.6.6-3~), python-ipaddr, python-netifaces, python-configobj, 
- python-epydoc, python-simpleparse, texlive-latex-base, texlive-latex-extra, texlive-latex-recommended, lmodern, ghostscript
-Standards-Version: 3.9.4
+Build-Depends: debhelper(>= 7.0.50~), python(>= 2.6.6-3~), python-ipaddr, python-netifaces, python-configobj, python-epydoc, python-simpleparse, texlive-latex-base, texlive-latex-extra, texlive-latex-recommended, lmodern, ghostscript
+Standards-Version: 3.9.2
 Homepage: http://www.risingtidesystems.com/git/?p=rtslib.git;a=summary
 Vcs-Git: git://git.debian.org/git/linux-target/rtslib.git
 Vcs-Browser: http://git.debian.org/?p=linux-target/rtslib.git

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with python2

override_dh_auto_clean:
	dh_auto_clean
	[ ! -d doc ] || rm -rf doc

override_dh_auto_build:
	dh_auto_build
	test -d doc || mkdir doc

	mkdir -p doc/pdf
	epydoc --no-sourcecode --pdf -n rtslib --exclude configobj rtslib/*.py
	mv pdf/api.pdf doc/pdf/rtslib_API_Documentation.pdf

	mkdir -p doc/html
	epydoc --no-sourcecode --html -n rtslib --exclude configobj rtslib/*.py
	mv html doc/

## rtslib 2.2

=== debian/changelog ===
rtslib (2.2-1) unstable; urgency=low

  * [0c63462] Add README.source
  * [71b9f19] Update Vcs links
  * [db42525] Imported Upstream version 2.2
  * [b37b36c] Switch license to Apache 2.0

 -- Ritesh Raj Sarraf <rrs@debian.org>  Sat, 03 Aug 2013 23:54:21 +0530

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,12 @@
 Source: rtslib
 Section: python
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Ritesh Raj Sarraf <rrs@debian.org>
+Maintainer: Ritesh Raj Sarraf <rrs@debian.org>
 Build-Depends: debhelper(>= 7.0.50~), python(>= 2.6.6-3~), python-ipaddr, python-netifaces, python-configobj, python-epydoc, python-simpleparse, texlive-latex-base, texlive-latex-extra, texlive-latex-recommended, lmodern, ghostscript
 Standards-Version: 3.9.2
 Homepage: http://www.risingtidesystems.com/git/?p=rtslib.git;a=summary
-Vcs-Git: git://git.debian.org/git/linux-target/rtslib.git
-Vcs-Browser: http://git.debian.org/?p=linux-target/rtslib.git
+Vcs-Git: git://anonscm.debian.org/linux-target/rtslib.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=linux-target/rtslib.git
 
 Package: python-rtslib
 Architecture: all

=== debian/rules ===
#!/usr/bin/make -f

build_dir   = build
install_dir = debian/tmp


%:
	dh $@ --with python2

override_dh_auto_clean:
	# manually clean any *.pyc files
	rm -rf rtslib/*.pyc
	[ ! -d doc ] || rm -rf doc

override_dh_auto_build:
	python setup.py build --build-base $(build_dir)
	test -d doc || mkdir doc

	mkdir -p doc/pdf
	epydoc --no-sourcecode --pdf -n rtslib --exclude configobj rtslib/*.py
	mv pdf/api.pdf doc/pdf/rtslib_API_Documentation.pdf
	
	mkdir -p doc/html
	epydoc --no-sourcecode --html -n rtslib --exclude configobj rtslib/*.py
	mv html doc/

override_dh_auto_install:
	python setup.py install --no-compile --install-purelib \
		$(install_dir)/lib --install-scripts $(install_dir)/bin

## rtslib 3.0~pre4.1~g1b33ceb

=== debian/changelog ===
rtslib (1:3.0~pre4.1~g1b33ceb-2) unstable; urgency=medium

  * [ee24baa] update README.source
  * Upload to Unstable

 -- Ritesh Raj Sarraf <rrs@debian.org>  Thu, 30 Apr 2015 16:27:38 +0530

rtslib (1:3.0~pre4.1~g1b33ceb-1) experimental; urgency=medium

  * New upstream release 

 -- Ritesh Raj Sarraf <rrs@debian.org>  Wed, 17 Dec 2014 18:01:03 +0530

rtslib (3.0+git0.86e46bc6-5) unstable; urgency=medium

  * [6298691] Revert "Add dh-python to build-depends"
    To comply with the freeze policy

 -- Ritesh Raj Sarraf <rrs@debian.org>  Fri, 07 Nov 2014 18:16:07 +0530

rtslib (3.0+git0.86e46bc6-4) unstable; urgency=medium

  * [acc103e] Install the policy files.
    Thanks to Jerome Martin (Closes: #764355)
  * [6cb7aac] Add dh-python to build-depends

 -- Ritesh Raj Sarraf <rrs@debian.org>  Tue, 04 Nov 2014 20:52:09 +0530

rtslib (3.0+git0.86e46bc6-3) unstable; urgency=medium

  * [5274ed0] Add some Depends on python modules.
    Thanks to Chris Boot (Closes: #764004)

 -- Ritesh Raj Sarraf <rrs@debian.org>  Sun, 19 Oct 2014 12:12:11 +0530

rtslib (3.0+git0.86e46bc6-2) unstable; urgency=medium

  * Upload to unstable 

 -- Ritesh Raj Sarraf <rrs@debian.org>  Sun, 28 Sep 2014 16:17:03 +0530

rtslib (3.0+git0.86e46bc6-1) experimental; urgency=medium

  * [662245d] Imported Upstream version 3.0+git0.86e46bc6
  * [b880691] Add python-pyparsing to build-dep
  * [ffb6cab] Disable tests for now as they are failing
  * [ac2342f] Add override for non-standard path
  * [f337fe0] Update copyright

 -- Ritesh Raj Sarraf <rrs@debian.org>  Sat, 20 Sep 2014 15:20:54 +0530

rtslib (2.2-2) unstable; urgency=medium

  * [95caeb5] Fix copyright to refer to Debian shipped license
  * debian/control
    - add "Build-Depends: texlive-fonts-recommended" to fix FTBFS due to
      changes in texlive (Closes: #743124). Thanks Hideki Yamane

 -- Ritesh Raj Sarraf <rrs@debian.org>  Thu, 03 Apr 2014 13:03:15 +0530

=== debian/control ===
Source: rtslib
Section: python
Priority: optional
Maintainer: Ritesh Raj Sarraf <rrs@debian.org>
Build-Depends: debhelper(>= 7.0.50~), python(>= 2.6.6-3~), python-ipaddr, python-netifaces, python-configobj, python-epydoc, python-simpleparse, texlive-latex-base, texlive-latex-extra, texlive-latex-recommended, lmodern, ghostscript, texlive-fonts-recommended, python-pyparsing
Standards-Version: 3.9.2
Homepage: http://www.risingtidesystems.com/git/?p=rtslib.git;a=summary
Vcs-Git: git://anonscm.debian.org/linux-target/rtslib.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=linux-target/rtslib.git

Package: python-rtslib
Architecture: all
Depends: ${python:Depends}, ${misc:Depends}, python-ipaddr, python-netifaces, python-configobj, python-pyparsing, python-prettytable
Provides: ${python:Provides}
Description: LIO core target management framework - Python libs
 This package contains the LIO rtslib library that provides an object API
 to the LIO SCSI Target as well as third-party target fabric modules
 .
 It is part of the Linux Kernel SCSI Target's userspace management library

=== debian/rules ===
--- 
+++ 
@@ -6,6 +6,9 @@
 
 %:
 	dh $@ --with python2
+
+override_dh_auto_test:
+	# Do nothing...
 
 override_dh_auto_clean:
 	# manually clean any *.pyc files

## rtslib 3.0+git0.86e46bc6

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
-# This file is part of RTSLib.
-# Copyright (c) 2011-2013 by Datera, Inc
+# This file is part of LIO(tm).
+# Copyright (c) 2011-2014 by Datera, Inc
 #
 # Licensed under the Apache License, Version 2.0 (the "License"); you may
 # not use this file except in compliance with the License. You may obtain
@@ -16,20 +16,49 @@
 
 NAME = rtslib
 GIT_BRANCH = $$(git branch | grep \* | tr -d \*)
-VERSION = $$(basename $$(git describe --tags | tr - .))
+GIT_DESC = $$(basename $$(git describe --tags | grep -o '[0-9].*$$'))
+GIT_LAST_TAG = $$(git describe --tags --abbrev=0 | grep -o '[0-9].*$$')
+GIT_PKG_TAG = $$(echo $(GIT_LAST_TAG) | tr - \~)
+VERSION = $$(echo $(GIT_DESC) | sed s/^$(GIT_LAST_TAG)/$(GIT_PKG_TAG)/)
+
+version:
+	@echo $(VERSION)
 
 all:
 	@echo "Usage:"
 	@echo
 	@echo "  make deb         - Builds debian packages."
+	@echo "  make debinstall  - Builds and installs debian packages."
+	@echo "                     (requires sudo access)"
 	@echo "  make rpm         - Builds rpm packages."
 	@echo "  make release     - Generates the release tarball."
+	@echo
+	@echo "  make test   	  - Runs the safe tests suite."
+	@echo "  make test-all 	  - Runs all tests, including dangerous system test."
+	@echo "                     This WILL mess-up your system target configuration!"
+	@echo "                     Requires sudo access to root privileges."
 	@echo
 	@echo "  make clean       - Cleanup the local repository build files."
 	@echo "  make cleanall    - Also remove dist/*"
 
+test:
+	@echo "Running the safe tests suite..."
+	@(PYTHONPATH=$$(pwd); cd tests/safe ; python -u -m unittest discover)
+
+test-all: test
+	@if [ ! -d "/sys/kernel/config/target" ]; then \
+		echo "Cannot run system tests, target is stopped."; \
+		exit 1; \
+	fi
+	@echo "Will run the DESTRUCTIVE system tests suite now."
+	@echo "This requires sudo access to root privileges."
+	@echo "These tests WILL mess-up your system target configuration!"
+	@echo "Type CTRL-C to abort now or enter to continue..."
+	@read X
+	@(PYTHONPATH=$$(pwd); cd tests/system ; sudo python -m unittest discover)
+
 clean:
-	@rm -fv ${NAME}/*.pyc ${NAME}/*.html
+	@rm -fv ${NAME}/*${NAME}/*.html
 	@rm -frv doc
 	@rm -frv ${NAME}.egg-info MANIFEST build
 	@rm -frv debian/tmp
@@ -42,6 +71,10 @@
 	@rm -frv results
 	@rm -fv rpm/*.spec *.spec rpm/sed* sed*
 	@rm -frv ${NAME}-*
+	@find . -name *.swp -exec rm -v {} \;
+	@find . -name *.pyc -exec rm -vf {} \;
+	@find . -name *~ -exec rm -v {} \;
+	@find . -name \#*\# -exec rm -v {} \;
 	@echo "Finished cleanup."
 
 cleanall: clean
@@ -53,6 +86,7 @@
 	@echo "Exporting the repository files..."
 	@git archive ${GIT_BRANCH} --prefix ${NAME}-${VERSION}/ \
 		| (cd build; tar xfp -)
+	@cp -pr debian/ build/${NAME}-${VERSION}
 	@echo "Cleaning up the target tree..."
 	@rm -f build/${NAME}-${VERSION}/Makefile
 	@rm -f build/${NAME}-${VERSION}/.gitignore
@@ -68,7 +102,7 @@
 		rm -r rpm
 	@echo "Generating rpm changelog..."
 	@( \
-		version=$$(basename $$(git describe HEAD --tags | tr - .)); \
+		version=$(VERSION); \
 		author=$$(git show HEAD --format="format:%an <%ae>" -s); \
 		date=$$(git show HEAD --format="format:%ad" -s \
 			| awk '{print $$1,$$2,$$3,$$5}'); \
@@ -78,7 +112,7 @@
 	) >> $$(ls build/${NAME}-${VERSION}/*.spec)
 	@echo "Generating debian changelog..."
 	@( \
-		version=$$(basename $$(git describe HEAD --tags | tr - .)); \
+		version=$(VERSION); \
 		author=$$(git show HEAD --format="format:%an <%ae>" -s); \
 		date=$$(git show HEAD --format="format:%aD" -s); \
 		day=$$(git show HEAD --format='format:%ai' -s \
@@ -117,6 +151,10 @@
 	@for pkg in $$(ls dist/*_${VERSION}_*.deb); do echo "  $${pkg}"; done
 	@touch build/deb-stamp
 
+debinstall: deb
+	@echo "Installing $$(ls dist/*_${VERSION}_*.deb)"
+	@sudo dpkg -i $$(ls dist/*_${VERSION}_*.deb)
+
 rpm: release build/rpm-stamp
 build/rpm-stamp:
 	@echo "Building rpm packages..."
